# generated by fastapi-codegen:
#   filename:  /home/stoller/testbed/portal-api/openapi.json
#   timestamp: 2025-03-27T13:12:53+00:00

from __future__ import annotations

from typing import Dict, List, Optional, Union
from uuid import UUID

from pydantic import (
    AnyUrl,
    AwareDatetime,
    BaseModel,
    ConfigDict,
    Field,
    RootModel,
    constr,
)


class Error(BaseModel):
    error: Optional[str] = Field(None, examples=['The main error message.'])
    errors: Optional[List[str]] = None


class ExperimentID(RootModel[Union[UUID, constr(pattern=r'^[-\w]+,[-\w]+$')]]):
    root: Union[UUID, constr(pattern=r'^[-\w]+,[-\w]+$')]


class AnyObject(BaseModel):
    pass
    model_config = ConfigDict(
        extra='allow',
    )


class Version(BaseModel):
    branch: Optional[str] = Field(None, examples=['master'])
    build_timestamp: Optional[AwareDatetime] = Field(
        None, examples=['2020-12-18T21:06:28.000Z']
    )
    commit: Optional[str] = Field(None, examples=['deadbeef'])
    major: int = Field(..., examples=[0])
    minor: int = Field(..., examples=[1])
    patch: int = Field(..., examples=[0])
    version: str = Field(..., examples=['0.1.0'])


class ExperimentCreate(BaseModel):
    name: str = Field(..., description='A human readable name for the experiment')
    project: str = Field(
        ..., description='The project the experiment is instantiated in.'
    )
    group: Optional[str] = Field(
        None, description='The project subgroup the experiment is instantiated in.'
    )
    profile_name: str = Field(..., description='The name of the profile.')
    profile_project: str = Field(..., description='The name of the profile project')
    start_at: Optional[AwareDatetime] = Field(None, description='Start time.')
    expires_at: Optional[AwareDatetime] = Field(None, description='Expiration time.')
    duration: Optional[int] = Field(
        None, description='Initial experiment duration, in hours.'
    )
    paramset_name: Optional[str] = Field(
        None, description='Optional name of a parameter set to apply to the profile'
    )
    paramset_owner: Optional[str] = Field(
        None, description='The owner of the parameter project'
    )
    bindings: Optional[AnyObject] = Field(
        None, description='Optional bindings to apply to the profile as a JSON object'
    )
    refspec: Optional[str] = Field(
        None, description='refspec[:hash] of a repo based profile to use'
    )


class ExperimentModify(BaseModel):
    bindings: AnyObject = Field(
        ..., description='Bindings to apply to the profile as a JSON string'
    )


class AggregateNode(BaseModel):
    urn: Optional[str] = Field(None, description='URN of the node')
    client_id: Optional[str] = Field(None, description='Logical name of the node')
    hostname: Optional[str] = Field(None, description='Qualified hostname of the node.')
    ipv4: Optional[str] = Field(None, description='IPV4 of the node.')
    status: Optional[str] = Field(None, description='Current status of the node')
    state: Optional[str] = Field(None, description='Current state of the node')
    rawstate: Optional[str] = Field(None, description='Current raw state of the node')
    startup_status: Optional[str] = Field(
        None, description='Current status of the startup  execution service'
    )


class UpdateAggregateNode(BaseModel):
    reboot: Optional[bool] = Field(None, description='Reboot node.')


class AggregateNodeList(BaseModel):
    nodes: Optional[List[AggregateNode]] = None


class ManifestArray(RootModel[Optional[Dict[str, str]]]):
    root: Optional[Dict[str, str]] = None


class ManifestList(RootModel[List[str]]):
    root: List[str]


class ResGroupReservation(BaseModel):
    resgroup_id: Optional[UUID] = Field(
        None, description='Unique identifier of the reservation group'
    )
    urn: Optional[str] = Field(None, description='Aggregate URN of the reservation')
    remote_id: Optional[UUID] = Field(
        None,
        description='Unique identifier of the reservation group reservation at the remote cluster',
    )
    nodetype: str = Field(..., description='Node type or node ID')
    count: int = Field(..., description='Number of nodes, if a node type')
    approved_at: Optional[AwareDatetime] = Field(None, description='Approval time.')
    canceled_at: Optional[AwareDatetime] = Field(None, description='Cancellation time.')
    deleted_at: Optional[AwareDatetime] = Field(None, description='Deletion time.')
    error: Optional[str] = Field(
        None, description='Error message regarding this reservation'
    )
    errorCode: Optional[int] = Field(
        None, description='Error code regarding this reservation'
    )


class ResGroupReservationList(RootModel[List[ResGroupReservation]]):
    root: List[ResGroupReservation]


class ResGroupRange(BaseModel):
    resgroup_id: Optional[UUID] = Field(
        None, description='Unique identifier of the reservation group'
    )
    range_id: Optional[UUID] = Field(
        None, description='Unique identifier of this range reservation'
    )
    min_freq: float = Field(
        ...,
        description='The start of the frequency range (inclusive) that this grant includes (MHz).',
    )
    max_freq: float = Field(
        ...,
        description='The end of the frequency range (inclusive) that this grant includes (MHz).',
    )
    approved_at: Optional[AwareDatetime] = Field(None, description='Approval time.')
    canceled_at: Optional[AwareDatetime] = Field(None, description='Cancellation time.')
    error: Optional[str] = Field(None, description='Error message regarding this range')
    errorCode: Optional[int] = Field(
        None, description='Error code regarding this range'
    )


class ResGroupRangeList(RootModel[List[ResGroupRange]]):
    root: List[ResGroupRange]


class ResGroupRoute(BaseModel):
    resgroup_id: Optional[UUID] = Field(
        None, description='Unique identifier of the reservation group'
    )
    route_id: Optional[UUID] = Field(
        None, description='Unique identifier of this route reservation'
    )
    name: str = Field(..., description='Route name')
    approved_at: Optional[AwareDatetime] = Field(None, description='Approval time.')
    canceled_at: Optional[AwareDatetime] = Field(None, description='Cancellation time.')


class ResGroupRouteList(RootModel[List[ResGroupRoute]]):
    root: List[ResGroupRoute]


class ExperimentsExperimentIdPatchRequest(BaseModel):
    bindings: str = Field(
        ..., description='Bindings to apply to the profile as a JSON object'
    )


class AggregateStatus(BaseModel):
    urn: Optional[str] = Field(None, description='URN of the aggregate.')
    name: Optional[str] = Field(
        None, description='Human readable name of the aggregate.'
    )
    status: Optional[str] = Field(None, description='Current status of the experiment.')
    nodes: Optional[List[AggregateNode]] = Field(
        None, description='List of nodes at the aggregate'
    )


class ResGroup(BaseModel):
    id: Optional[UUID] = Field(
        None, description='Unique identifier of the reservation group'
    )
    reason: Optional[str] = Field(
        None, description='Pithy description of why you want to reserve these resources'
    )
    project: str = Field(..., description='The project of the reservation group')
    group: Optional[str] = Field(
        None, description='The project subgroup of the reservation group'
    )
    creator: Optional[str] = Field(None, description='The name of the creator.')
    created_at: Optional[AwareDatetime] = Field(None, description='Creation time.')
    start_at: Optional[AwareDatetime] = Field(
        None, description='Last modification time.'
    )
    expires_at: AwareDatetime = Field(..., description='Expiration time.')
    powder_zones: Optional[str] = Field(
        None,
        description='Powder only; specify the powder zones when creating range only reservation group',
    )
    clusters: Optional[ResGroupReservationList] = None
    ranges: Optional[ResGroupRangeList] = None
    routes: Optional[ResGroupRouteList] = None


class ResGroupError(BaseModel):
    error: Optional[str] = Field(
        None, description='Error message regarding this reservation group'
    )
    errorCode: Optional[int] = Field(
        None, description='Error code regarding this reservation group'
    )
    clusters: Optional[ResGroupReservationList] = None
    ranges: Optional[ResGroupRangeList] = None
    routes: Optional[ResGroupRouteList] = None


class ResGroupList(BaseModel):
    resgroups: Optional[List[ResGroup]] = None


class Experiment(BaseModel):
    id: UUID = Field(..., description='Unique identifier of the experiment.')
    name: Optional[str] = Field(
        None, description='A human readable name for the experiment .'
    )
    project: Optional[str] = Field(
        None, description='The project the experiment is instantiated in.'
    )
    group: Optional[str] = Field(
        None, description='The project subgroup the experiment is instantiated in.'
    )
    profile_id: Optional[UUID] = Field(
        None, description='ID of the profile used to create the experiment'
    )
    profile_name: Optional[str] = Field(
        None, description='Human readable name of the profile.'
    )
    profile_project: Optional[str] = Field(
        None, description='Human readable name of the profile project'
    )
    creator: Optional[str] = Field(None, description='The name of the creator.')
    updater: Optional[str] = Field(None, description='The name of the updater.')
    created_at: Optional[AwareDatetime] = Field(None, description='Creation time.')
    started_at: Optional[AwareDatetime] = Field(None, description='Start time.')
    start_at: Optional[AwareDatetime] = Field(
        None, description='Last modification time.'
    )
    stop_at: Optional[AwareDatetime] = Field(
        None, description='Last modification time.'
    )
    expires_at: Optional[AwareDatetime] = Field(None, description='Expiration time.')
    status: Optional[str] = Field(None, description='Current status of the experiment.')
    wbstore_id: Optional[str] = Field(
        None, description='The ID of the experiments WB store.'
    )
    url: Optional[AnyUrl] = Field(None, description='The URL of the Portal status page')
    bindings: Optional[AnyObject] = Field(
        None, description='Bindings applied to the profile as a JSON string'
    )
    aggregates: Optional[Dict[str, AggregateStatus]] = Field(
        None, description='List of aggregates in the experiment'
    )


class AggregateArray(RootModel[Optional[Dict[str, AggregateStatus]]]):
    root: Optional[Dict[str, AggregateStatus]] = None


class AggregateList(BaseModel):
    aggregates: Optional[List[AggregateStatus]] = None


class ExperimentList(BaseModel):
    experiments: Optional[List[Experiment]] = None
